from pygsl import bspline, multifit, rng
import pygsl._numobj as numx

N = 200
ncoeffs = 8
nbreak = ncoeffs - 2
bspline = bspline.pygsl_bspline
def run():
    r = rng.rng()
    bw = bspline(4, nbreak)


    
    x = 15. / (N-1) * numx.arange(N)
    y = numx.cos(x) * numx.exp(0.1 * x)    
    sigma = .1
    w = 1.0 / sigma**2 * numx.ones(N) 
    dy = r.gaussian(sigma, N)
    y  = y + dy

    bw.knots_uniform(0.0, 15.0)

    X = numx.zeros((N, ncoeffs))

    for i in range(N):
        xi = x[i]
        B = bw.eval(xi)
        X[i,:] = B

        
    pass
    c, cov, chisq = multifit.wlinear(X, w, y, multifit.linear_workspace(N, ncoeffs))

    for i in range(N):
        yi, yerr = multifit.linear_est(B, c, cov)
if __name__ == '__main__':
    run()

